using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace P12_1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        //   
        GraphicsDeviceManager graphics;
        //  
        SpriteBatch spriteBatch;
        // -
        Ball b;
        //   
        KeyboardState Kb;
        //  
        NetworkSession networkSession;
        //     
        PacketWriter packetWriter;
        PacketReader packetReader;


        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            //  GamerServiceComponent
            Components.Add(new GamerServicesComponent(this));
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            //      
            //   
            packetWriter = new PacketWriter();
            packetReader = new PacketReader();
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            //  
            b = new Ball(Content, this);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }
        

        
        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // 
            Kb = Keyboard.GetState();
            //    
            if (networkSession == null)
            {
                //   
                if (IsActive)
                {
                    //       
                    if (Gamer.SignedInGamers.Count == 0)
                    {
                       //     -  
                        if (!Guide.IsVisible)
                            Guide.ShowSignIn(2, false);
                    }
                    else
                        //    
                        // ,   
                        //   
                        //   -  
                        TryToJoinOrCreate();
                }
            }
            else
                //   
                //    
                WorkWithSession();
            
            base.Update(gameTime);
        }

        //,      
        //  
        void TryToJoinOrCreate()
        {
            //    
            this.Window.Title = "  ";
            //     SystemLink -  
            //    ,    ,
            // 
            using (AvailableNetworkSessionCollection availNetSessions =
                NetworkSession.Find(NetworkSessionType.SystemLink,
                2, null))
            {
                //    
                if (availNetSessions.Count == 0)
                {
                    this.Window.Title = "   -   ";
                    //  
                    networkSession = NetworkSession.Create(NetworkSessionType.SystemLink,
                        1, 2);
                    //  
                    JoinEventhandlers();
                    this.Window.Title = " ";
                }
               //,   
                else
                {
                    this.Window.Title = " , ";
                    //       
                    networkSession = NetworkSession.Join(availNetSessions[0]);
                    JoinEventhandlers();

                }
            }

        }
        //  
        void JoinEventhandlers()
        {
            //  NetworkSession   
            // ,    ,  ,      
            //  , .     
            //   ,      ,   
            networkSession.GamerJoined += new EventHandler<GamerJoinedEventArgs>(networkSession_GamerJoined);
            //    
            networkSession.SessionEnded += new EventHandler<NetworkSessionEndedEventArgs>(networkSession_SessionEnded);
        }
        // ,     
        void networkSession_GamerJoined(object sender, GamerJoinedEventArgs e)
        {
            //  
            int plNumber = networkSession.AllGamers.IndexOf(e.Gamer);
            //   Tag ,    Object,   - 
            //  ,   Bat.  ,   
            //,    .        
            //  0        ,   1 - 
            // . ,  ,    
            e.Gamer.Tag = new Bat(plNumber, Content, this);
        }

        // ,    
        void networkSession_SessionEnded(object sender, NetworkSessionEndedEventArgs e)
        {
            // 
            networkSession.Dispose();
            networkSession = null;
        }

        //     
        void WorkWithSession()
        {
            // ,     
            //   -         0
            //     
            CalcAndWrite(networkSession.LocalGamers[0]);
            //  
     
            networkSession.Update();
            //    -   
            if (networkSession == null) return;
            //      
            ReadAndImplement(networkSession.LocalGamers[0]);
        }
        //     
        void CalcAndWrite(LocalNetworkGamer gamer)
        {
            // ,   Tag  
            //  - Bat
            Bat bat = gamer.Tag as Bat;
            //      
            //    
            if (Kb.IsKeyDown(Keys.Up))
            {
                bat.sprPosition.Y -= 3;
            }
            //  - 
            if (Kb.IsKeyDown(Keys.Down))
            {
                bat.sprPosition.Y += 3;
            }
            //    
            packetWriter.Write(bat.sprPosition);
            //   - ,    
            // ,    
            //     
            if (gamer.IsHost)
            {
                //    2 
                //   
                if (networkSession.AllGamers.Count == 2)
                {
                    //      
                    //
                    b.sprPosition += b.sprSpeed;
                    //       
                    if (b.sprPosition.Y < b.scrBounds.Y)
                    {
                        //      Y
                        b.sprPosition.Y = b.scrBounds.Y;
                        b.sprSpeed.Y *= -1;
                    }
                    //    
                    //      Y
                    if (b.sprPosition.Y + b.sprRectangle.Height > b.scrBounds.Height)
                    {
                        b.sprPosition.Y = b.scrBounds.Height - b.sprRectangle.Height;
                        b.sprSpeed.Y *= -1;
                    }
                    //    0 -   
                    //      
                    bat = networkSession.AllGamers[0].Tag as Bat;
                    //    
                    if (b.sprPosition.X + b.sprRectangle.Width > bat.sprPosition.X &&
                    b.sprPosition.X < bat.sprPosition.X + bat.sprRectangle.Width &&
                    b.sprPosition.Y + b.sprRectangle.Height > bat.sprPosition.Y &&
                    b.sprPosition.Y < bat.sprPosition.Y + bat.sprRectangle.Height)
                    {
                        //      X
                        b.sprPosition.X = bat.sprRectangle.Width;
                        b.sprSpeed.X *= -1;
                    }
                    //    1 -   
                    bat = networkSession.AllGamers[1].Tag as Bat;
                    //    
                    if (b.sprPosition.X + b.sprRectangle.Width > bat.sprPosition.X &&
                    b.sprPosition.X < bat.sprPosition.X + bat.sprRectangle.Width &&
                    b.sprPosition.Y + b.sprRectangle.Height > bat.sprPosition.Y &&
                    b.sprPosition.Y < bat.sprPosition.Y + bat.sprRectangle.Height)
                    {
                        //      X
                        b.sprPosition.X = b.scrBounds.Width - bat.sprRectangle.Width - b.sprRectangle.Width;
                        b.sprSpeed.X *= -1;
                    }

                }
                //     
                packetWriter.Write(b.sprPosition);
            }
            //   
            gamer.SendData(packetWriter, SendDataOptions.InOrder);
        }
        //       
        void ReadAndImplement(LocalNetworkGamer gamer)
        {
            //  ,     
            while (gamer.IsDataAvailable)
            {
                //  sender  NetworkGamer
                //       
                //  
                NetworkGamer sender;

                //  
                gamer.ReceiveData(packetReader, out sender);

                //      -   - 
                //        (      
                // 
                if (!sender.IsLocal)
                {

                    //  bat   Tag ,  
                    Bat bat = sender.Tag as Bat;
                    //       
                    bat.sprPosition = packetReader.ReadVector2();
                    //   -  -  
                    // ,    
                    //         
                    //       -   
                    //  
                    if (sender.IsHost) b.sprPosition = packetReader.ReadVector2();
                }
            }
        }


        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
            //  
            spriteBatch.Begin();
            //        2
            //  -     
            if (networkSession!=null && networkSession .AllGamers .Count==2)
            {
                //     ,     
                foreach (NetworkGamer gamer in networkSession.AllGamers)
                {
                    //  bat   
                    Bat bat = gamer.Tag as Bat;

                    //  bat
                    bat.Draw(spriteBatch);
                    // 
                    b.Draw(spriteBatch);
                }
            }
            //  
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
